<?php

if (!defined('SMF'))
	die('Hacking attempt...');

function get_total_unapproved_posts()
{
	global $smcFunc, $context;

	$approve_boards = boardsAllowedTo('approve_posts');

	if ($approve_boards == array(0))
		$approve_query = '';
	elseif (!empty($approve_boards))
		$approve_query = ' AND m.id_board IN (' . implode(',', $approve_boards) . ')';
	else
		$approve_query = ' AND 0';

	if (($context['total_unapproved_posts'] = cache_get_data('total_unapproved_posts', 3600)) === null)
	{
		$request = $smcFunc['db_query']('', '
			SELECT COUNT(*)
			FROM {db_prefix}messages AS m
				INNER JOIN {db_prefix}topics AS t ON (t.id_topic = m.id_topic AND t.id_first_msg != m.id_msg)
				INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			WHERE m.approved = {int:not_approved}
				AND {query_see_board}
				' . $approve_query,
			array(
				'not_approved' => 0,
			)
		);
		list ($context['total_unapproved_posts']) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);

		cache_put_data('total_unapproved_posts', $context['total_unapproved_posts'], 3600);
	}

	if (($context['total_unapproved_topics'] = cache_get_data('total_unapproved_topics', 3600)) === null)
	{
		$request = $smcFunc['db_query']('', '
			SELECT COUNT(m.id_topic)
			FROM {db_prefix}topics AS m
				INNER JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
			WHERE m.approved = {int:not_approved}
				AND {query_see_board}
				' . $approve_query,
			array(
				'not_approved' => 0,
			)
		);
		list ($context['total_unapproved_topics']) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);

		cache_put_data('total_unapproved_topics', $context['total_unapproved_topics'], 3600);
	}

	$context['total_unapproved_posts'] = $context['total_unapproved_posts'] + $context['total_unapproved_topics'];
}

function edit_moderate_button(&$menu_buttons)
{
	global $context, $user_info;

	if (!$user_info['is_guest'] && $context['user']['can_mod'] && $context['total_unapproved_posts'] > 0 && isset($menu_buttons['moderate']))
	{
		$menu_buttons['moderate']['alttitle'] = $menu_buttons['moderate']['title'] . ' [' . $context['total_unapproved_posts'] . ']';
		$menu_buttons['moderate']['title'] .= ' [<strong>' . $context['total_unapproved_posts'] . '</strong>]';
	}
}

?>